Loading...
Searching...
No Matches
CStaticObject Class Reference
Inheritance diagram for CStaticObject:
[legend]

## Public Member Functions

| CStaticObject (int id, ObjectType type, const std::string &key, const Math::Vector &position, float angleY, const Gfx::CModel &model, Gfx::CEngine *engine)
void | Read (CLevelParserLine *line) override
| Reads object properties from line in level file.
void | Write (CLevelParserLine *line) override
| Writes object properties to line in level file.
void | SetTransparency (float value) override
| Sets the transparency of object.
Public Member Functions inherited from CObject
| CObject (const CObject &)=delete
CObject & | operator= (const CObject &)=delete
ObjectType | GetType () const
| Returns object type.
int | GetID () const
| Returns object's unique id.
virtual void | UpdateInterface ()
| Updates all interface controls.
bool | Implements (ObjectInterfaceType type) const
| Check if object implements the given type of interface.
virtual Math::Vector | GetPosition () const
| Returns object's position.
virtual void | SetPosition (const Math::Vector &pos)
| Sets object's position.
virtual Math::Vector | GetRotation () const
| Returns object's rotation (Euler angles).
virtual void | SetRotation (const Math::Vector &rotation)
| Sets object's rotation (Euler angles).
virtual Math::Vector | GetScale () const
| Returns object's scale.
virtual void | SetScale (const Math::Vector &scale)
| Sets objects's scale.
void | SetScale (float scale)
| Sets objects's scale (uniform value).
void | SetCrashSpheres (const std::vector< Gfx::ModelCrashSphere > &crashSpheres)
| Sets crash spheres for object.
void | AddCrashSphere (const CrashSphere &crashSphere)
| Adds a new crash sphere.
int | GetCrashSphereCount ()
| Returns total number of crash spheres.
CrashSphere | GetFirstCrashSphere ()
| Returns the first crash sphere (assumes it exists).
std::vector< CrashSphere > | GetAllCrashSpheres ()
| Returns all crash spheres.
void | DeleteAllCrashSpheres ()
| Removes all crash spheres.
bool | CanCollideWith (CObject *other)
| Returns true if this object can collide with the other one.
Math::Sphere | GetCameraCollisionSphere ()
| Returns sphere used to test for camera collisions.
void | SetCameraCollisionSphere (const Math::Sphere &sphere)
| Sets sphere used to test for camera collisions.
void | SetAnimateOnReset (bool animateOnReset)
| Sets flag controlling animation effect on level reset.
bool | GetAnimateOnReset ()
| Returns flag controlling animation effect on level reset.
void | SetCollisions (bool collisions)
| Turns object collisions on/off.
bool | GetCollisions ()
| Returns true if collisions are enabled.
void | SetTeam (int team)
| Sets object team (shouldn't be called after creation because the model won't update!).
int | GetTeam ()
| Returns object team.
void | SetProxyActivate (bool activate)
| Enable object activation only after you come close.
bool | GetProxyActivate ()
| Returns close activation mode.
void | SetProxyDistance (float distance)
| Sets distance for close activation.
float | GetProxyDistance ()
| Returns distance for close activation.
CBot::CBotVar * | GetBotVar ()
| Returns CBot "object" variable associated with this object.
std::string | GetTooltipText ()
| Returns tooltip text for an object.
void | SetLock (bool lock)
| Set "lock" mode of an object (for example, a robot while it's being factored, or a building while it's built).
bool | GetLock ()
| Return "lock" mode of an object.
virtual bool | GetActive ()
| Is this object active (not dead)?
virtual bool | GetDetectable ()
| Is this object detectable (not dead and not underground)?
virtual bool | IsBulletWall ()
void | SetRotationX (float angle)
void | SetRotationY (float angle)
void | SetRotationZ (float angle)
float | GetRotationX ()
float | GetRotationY ()
float | GetRotationZ ()
void | SetScaleX (float angle)
void | SetScaleY (float angle)
void | SetScaleZ (float angle)
float | GetScaleX ()
float | GetScaleY ()
float | GetScaleZ ()
Public Member Functions inherited from COldObjectInterface
virtual void | Simplify ()
virtual void | DeletePart (int part)
virtual void | SetType (ObjectType type)
virtual int | GetObjectRank (int part)
virtual int | GetOption ()
virtual void | SetDrawFront (bool bDraw)
virtual void | FloorAdjust ()
virtual void | SetLinVibration (Math::Vector dir)
virtual void | SetCirVibration (Math::Vector dir)
virtual Math::Vector | GetTilt ()
virtual void | SetMasterParticle (int part, int parti)
virtual Math::Matrix * | GetWorldMatrix (int part)
virtual Character * | GetCharacter ()
virtual void | FlatParent ()
virtual void | SetVirusMode (bool bEnable)
virtual bool | GetVirusMode ()
virtual CAuto * | GetAuto ()

## Static Public Member Functions

static bool | IsStaticObject (ObjectType type)
static CStaticObjectUPtr | Create (int id, ObjectType type, const Math::Vector &position, float angleY, float height, Gfx::CEngine *engine, Gfx::CModelManager *modelManager, Gfx::CTerrain *terrain)
Static Public Member Functions inherited from CObject
static ObjectCreateParams | ReadCreateParams (CLevelParserLine *line)
| Reads params required for object creation.

## Protected Member Functions

void | TransformCrashSphere (Math::Sphere &crashSphere) override
| Transform crash sphere by object's world matrix.
void | TransformCameraCollisionSphere (Math::Sphere &collisionSphere) override
| Transform crash sphere by object's world matrix.
Protected Member Functions inherited from CObject
| CObject (int id, ObjectType type)
| Constructor only accessible to subclasses.

## Additional Inherited Members

Protected Attributes inherited from CObject
const int | m_id
| unique identifier
ObjectType | m_type
| object type
ObjectInterfaceTypes | m_implementedInterfaces
| interfaces that the object implements
Math::Vector | m_position
Math::Vector | m_rotation
Math::Vector | m_scale
std::vector< CrashSphere > | m_crashSpheres
| crash spheres
Math::Sphere | m_cameraCollisionSphere
bool | m_animateOnReset
bool | m_collisions
int | m_team
bool | m_proxyActivate
float | m_proxyDistance
CBot::CBotVar * | m_botVar
bool | m_lock

## Member Function Documentation

## Read()

void CStaticObject::Read | ( | CLevelParserLine * | line | ) |

override virtual

Reads object properties from line in level file.

Implements CObject.

## Write()

void CStaticObject::Write | ( | CLevelParserLine * | line | ) |

override virtual

Writes object properties to line in level file.

Implements CObject.

## SetTransparency()

void CStaticObject::SetTransparency | ( | float | value | ) |

override virtual

Sets the transparency of object.

Implements CObject.

## TransformCrashSphere()

void CStaticObject::TransformCrashSphere | ( | Math::Sphere & | crashSphere | ) |

override protected virtual

Transform crash sphere by object's world matrix.

Implements CObject.

## TransformCameraCollisionSphere()

void CStaticObject::TransformCameraCollisionSphere | ( | Math::Sphere & | collisionSphere | ) |

override protected virtual

Transform crash sphere by object's world matrix.

Implements CObject.

The documentation for this class was generated from the following files:

- src/object/subclass/static_object.h
- src/object/subclass/static_object.cpp